class Animal:
    def __init__(self, nombre, especie):
        self.nombre = nombre
        self.especie = especie


class Mamifero(Animal):
    def __init__(self, nombre, especie, peso):
        super().__init__(nombre, especie)
        self.peso = peso

    def calcular_comida(self):
        return self.peso * 0.1

class Ave(Animal):
    def __init__(self, nombre, especie, envergadura):
        super().__init__(nombre, especie)
        self.envergadura = envergadura

    def calcular_comida(self):
        return self.envergadura * 0.05


class Zoo:
    def __init__(self):
        self.animales = []

    def anadir_animal(self, animal):
        self.animales.append(animal)

    def calcular_consumo_comida(self):
        total_consumo = 0
        for a in self.animales:
            total_consumo += a.calcular_comida()

        print("Comida total consumida", total_consumo)


mizoo = Zoo()  # Crear instancia de un zoo

# Crear instancias de los animales del enunciado
dumbo = Mamifero("Dumbo", "Elefante", 5000)
simba = Mamifero("Simba", "Leon", 250)
atila = Ave("Atila", "Halcón", 2.5)
charlie = Ave("Charlie", "Loro", 0.15)

# Añadir animales al zoo
mizoo.anadir_animal(dumbo)
mizoo.anadir_animal(simba)
mizoo.anadir_animal(atila)
mizoo.anadir_animal(charlie)

# Mostrar consumo total de comida del zoo
mizoo.calcular_consumo_comida()
