import socket
import sys

# Recibir puerto de terminal (argumento por línea de comandos)
puerto = int(sys.argv[1])

# Crea un socket TCP
server_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

# Vincula el socket a una dirección y puerto específicos
ip = socket.gethostbyname(socket.gethostname())
server_socket.bind((ip, puerto))
server_socket.listen()  # Poner servidor a escuchar conexiones

print(f"El servidor TCP está escuchando en la ip {ip} el puerto {puerto}")

try:
    while True:  # While para atender clientes secuencialmente
        client_socket, addr = server_socket.accept()  # Aceptar conexi'on
        if client_socket:
            datos = client_socket.recv(1024)  # Recibir mensaje
            if not datos:  # Cliente cierra socket
                print("Cliente desconectado: ", addr)
                break
            print(f"Recibido dato de {addr}: {datos.decode()}")

            respuesta = "¡Hola, cliente!"
            client_socket.sendall(respuesta.encode())  # Responder al cliente
except KeyboardInterrupt:
    server_socket.close()
