
class Recurso:
    def __init__(self, titulo, autor):
        self.titulo = titulo
        self.autor = autor


class Libro(Recurso):
    def __init__(self, titulo, autor, paginas):
        super().__init__(titulo, autor)
        self.paginas = paginas

    def mostrar(self):
        print(f'{self.titulo}, de {self.autor} ({self.paginas} pág.)')


class Revista(Recurso):
    def __init__(self, titulo, autor, edicion):
        super().__init__(titulo, autor)
        self.edicion = edicion

    def mostrar(self):
        print(f'{self.titulo}, de {self.autor} ({self.edicion})')


class Biblioteca:
    def __init__(self):
        self.recursos = dict()
        self.recursos['A-I'] = []
        self.recursos['J-R'] = []
        self.recursos['S-Z'] = []

    def agregar_recurso(self, rec):
        inicial = rec.autor.upper()[0]
        if inicial < 'J':
            self.recursos['A-I'].append(rec)
        elif inicial < 'S':
            self.recursos['J-R'].append(rec)
        else:
            self.recursos['S-Z'].append(rec)

    def mostrar_recursos(self):
        for key, lista in self.recursos.items():
            print(f'--- {key} ---')
            for rec in lista:
                rec.mostrar()


# Crear algunos recursos
libro1 = Libro('Don Quijote de la Mancha', 'Miguel de Cervantes', 200)
revista1 = Revista('National Geographic', 'John Doe', 'Edición de Enero de 2023')

# Crear una biblioteca
biblioteca = Biblioteca()

# Agregar los recursos a la biblioteca
biblioteca.agregar_recurso(libro1)
biblioteca.agregar_recurso(revista1)

# Mostrar todos los recursos en la biblioteca
biblioteca.mostrar_recursos()
