import socket
import threading
import sys


# Config
SERVER_HOST = sys.argv[1]  # La direccion IP del servidor
SERVER_PORT = int(sys.argv[2])  # El puerto en el que el servidor esta escuchando
PALABRA = sys.argv[3].upper()


def comunicacion_cliente(socket, ip):
    print("Client connected from ", ip)
    intentos = 0
    while True:
        data = socket.recv(1024)
        if not data:
            print("Client disconnected", ip)
            socket.close()
            break
        elif data.decode() == '0':
            print("Acierto! Cerrando conexión con", ip)
            socket.close()
            break
        else:
            intentos += 1
            palabra = data.decode().upper()
            assert len(palabra) == len(PALABRA)
            respuesta = ""
            for i, letra in enumerate(palabra):
                if letra == PALABRA[i]:
                    respuesta += 'X'
                elif letra in PALABRA:
                    respuesta += '?'
                else:
                    respuesta += '-'

            socket.sendall(respuesta.encode())  # Response
            print("Intento: " + str(intentos) + " " + data.decode() + " Clave: " + PALABRA + " Respuesta: " + respuesta)

            if intentos == 5:
                socket.sendall(PALABRA.encode())  # Response


print("Starting threaded TCP server")
tcps = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
tcps.bind((SERVER_HOST, SERVER_PORT))
tcps.listen(1)

try:
    while True:
        conn, addr = tcps.accept()
        threading.Thread(target=comunicacion_cliente, args=(conn, addr)).start()
except:
    pass
finally:
    tcps.close()
