class Nodo:
    def __init__(self, dato, siguiente=None):
        self.dato = dato
        self.next = siguiente


class Pila:
    def __init__(self):
        self.cima = None
        self.size = 0

    def push(self, dato):
        # Crear el nodo con el nuevo dato
        nuevo = Nodo(dato)

        # Hacer que el nodo nuevo apunte a la cima actual
        nuevo.next = self.cima

        # Cambiar la cima para que apunte al nuevo
        self.cima = nuevo

        # Incrementar el tamaño
        self.size += 1

    def pop(self):
        # Si no hay elementos, devuelvo None
        if self.cima is None:
            return None
        # Si hay algo, recupero el valor
        valor = self.cima.dato
        # Hago que la cima apunte al segundo
        self.cima = self.cima.next
        self.size -= 1  # Dismimuyo el tamaño
        return valor


def es_palindromo(palabra):
    pila = Pila()

    # Llenar la pila con la palabra
    for letra in palabra:
        pila.push(letra)

    # Recorrer la palabra letra a letra y compararlo con las que salen de la pila (orden inverso)
    for letra in palabra:
        if letra != pila.pop():
            return False
    return True


# Programa principal
if __name__ == "__main__":
    palabra = input("Introduzca una palabra: ")
    if es_palindromo(palabra):
        print(f'"{palabra}" es un palíndromo.')
    else:
        print(f'"{palabra}" no es un palíndromo.')